#pragma once
#include "source2sdk/client/BreakableContentsType_t.hpp"
#include "source2sdk/client/PerformanceMode_t.hpp"
#include "source2sdk/entity2/CEntityIOOutput.hpp"
#include "source2sdk/entity2/GameTime_t.hpp"
#include "source2sdk/server/CBaseProp.hpp"
#include "source2sdk/server/CPropDataComponent.hpp"
#include "source2sdk/source2gen.hpp"
#include <cstddef>
#include <cstdint>

// /////////////////////////////////////////////////////////////
// Module: server
// Created using source2gen - github.com/neverlosecc/source2gen
// /////////////////////////////////////////////////////////////

namespace source2sdk::server
{
    class CBaseEntity;
};

namespace source2sdk::server
{
    class CBasePlayerPawn;
};

namespace source2sdk::server
{
    // Registered alignment: 0x8
    // Alignment: 0x8
    // Standard-layout class: false
    // Size: 0xb50
    // Has VTable
    // 
    // static metadata: MNetworkVarNames "CPropDataComponent::Storage_t m_CPropDataComponent"
    // static metadata: MNetworkVarNames "bool m_noGhostCollision"
    #pragma pack(push, 1)
    class CBreakableProp : public server::CBaseProp
    {
    public:
        [[maybe_unused]] std::uint8_t pad_0x9e0[0x8]; // 0x9e0
        // metadata: MNetworkEnable
        // metadata: MNetworkUserGroup "CPropDataComponent"
        // metadata: MNetworkAlias "CPropDataComponent"
        // metadata: MNetworkTypeAlias "CPropDataComponent"
        server::CPropDataComponent m_CPropDataComponent; // 0x9e8        
        entity2::CEntityIOOutput m_OnBreak; // 0xa28        
        // m_OnHealthChanged has a template type with potentially unknown template parameters. You can try uncommenting the field below.
        // CEntityOutputTemplate<float> m_OnHealthChanged;
        char m_OnHealthChanged[0x28]; // 0xa50        
        entity2::CEntityIOOutput m_OnTakeDamage; // 0xa78        
        float m_impactEnergyScale; // 0xaa0        
        int32_t m_iMinHealthDmg; // 0xaa4        
        QAngle m_preferredCarryAngles; // 0xaa8        
        float m_flPressureDelay; // 0xab4        
        float m_flDefBurstScale; // 0xab8        
        Vector m_vDefBurstOffset; // 0xabc        
        // m_hBreaker has a template type with potentially unknown template parameters. You can try uncommenting the field below.
        // CHandle<server::CBaseEntity> m_hBreaker;
        char m_hBreaker[0x4]; // 0xac8        
        client::PerformanceMode_t m_PerformanceMode; // 0xacc        
        entity2::GameTime_t m_flPreventDamageBeforeTime; // 0xad0        
        client::BreakableContentsType_t m_BreakableContentsType; // 0xad4        
        CUtlString m_strBreakableContentsPropGroupOverride; // 0xad8        
        CUtlString m_strBreakableContentsParticleOverride; // 0xae0        
        bool m_bHasBreakPiecesOrCommands; // 0xae8        
        [[maybe_unused]] std::uint8_t pad_0xae9[0x3]; // 0xae9
        float m_explodeDamage; // 0xaec        
        float m_explodeRadius; // 0xaf0        
        [[maybe_unused]] std::uint8_t pad_0xaf4[0x4]; // 0xaf4
        float m_explosionDelay; // 0xaf8        
        [[maybe_unused]] std::uint8_t pad_0xafc[0x4]; // 0xafc
        CUtlSymbolLarge m_explosionBuildupSound; // 0xb00        
        CUtlSymbolLarge m_explosionCustomEffect; // 0xb08        
        CUtlSymbolLarge m_explosionCustomSound; // 0xb10        
        CUtlSymbolLarge m_explosionModifier; // 0xb18        
        // m_hPhysicsAttacker has a template type with potentially unknown template parameters. You can try uncommenting the field below.
        // CHandle<server::CBasePlayerPawn> m_hPhysicsAttacker;
        char m_hPhysicsAttacker[0x4]; // 0xb20        
        entity2::GameTime_t m_flLastPhysicsInfluenceTime; // 0xb24        
        bool m_bOriginalBlockLOS; // 0xb28        
        [[maybe_unused]] std::uint8_t pad_0xb29[0x3]; // 0xb29
        float m_flDefaultFadeScale; // 0xb2c        
        // m_hLastAttacker has a template type with potentially unknown template parameters. You can try uncommenting the field below.
        // CHandle<server::CBaseEntity> m_hLastAttacker;
        char m_hLastAttacker[0x4]; // 0xb30        
        // m_hFlareEnt has a template type with potentially unknown template parameters. You can try uncommenting the field below.
        // CHandle<server::CBaseEntity> m_hFlareEnt;
        char m_hFlareEnt[0x4]; // 0xb34        
        bool m_bUsePuntSound; // 0xb38        
        [[maybe_unused]] std::uint8_t pad_0xb39[0x7]; // 0xb39
        CUtlSymbolLarge m_iszPuntSound; // 0xb40        
        // metadata: MNetworkEnable
        bool m_noGhostCollision; // 0xb48        
        [[maybe_unused]] std::uint8_t pad_0xb49[0x7];
        
        // Datamap fields:
        // void InputBreak; // 0x0
        // int32_t InputSetHealth; // 0x0
        // int32_t InputAddHealth; // 0x0
        // int32_t InputRemoveHealth; // 0x0
        // bool InputSetNavIgnore; // 0x0
        // void InputEnablePuntSound; // 0x0
        // void InputDisablePuntSound; // 0x0
        // void CBreakablePropBreakThink; // 0x0
        // void CBreakablePropRampToDefaultFadeScale; // 0x0
        // uint32_t m_nExplosionType; // 0xaf4
    };
    #pragma pack(pop)
    
    // Cannot assert offsets of fields in CBreakableProp because it is not a standard-layout class
    static_assert(sizeof(CBreakableProp) == 0xb50);
};
